package apis

import (
    "fmt"

	"github.com/gin-gonic/gin"
	"github.com/go-admin-team/go-admin-core/sdk/api"
	"github.com/go-admin-team/go-admin-core/sdk/pkg/jwtauth/user"
	_ "github.com/go-admin-team/go-admin-core/sdk/pkg/response"

	"go-admin/app/admin/models"
	"go-admin/app/admin/service"
	"go-admin/app/admin/service/dto"
	"go-admin/common/actions"
)

type MemberBalanceLog struct {
	api.Api
}

// GetPage 获取用户余额变更记录列表
// @Summary 获取用户余额变更记录列表
// @Description 获取用户余额变更记录列表
// @Tags 用户余额变更记录
// @Param changeSource query string false "变更来源 (member_change_source)"
// @Param changeType query string false "变更类别 1-收入 2-支出"
// @Param pageSize query int false "页条数"
// @Param pageIndex query int false "页码"
// @Success 200 {object} response.Response{data=response.Page{list=[]models.MemberBalanceLog}} "{"code": 200, "data": [...]}"
// @Router /api/v1/member-balance-log [get]
// @Security Bearer
func (e MemberBalanceLog) GetPage(c *gin.Context) {
    req := dto.MemberBalanceLogGetPageReq{}
    s := service.MemberBalanceLog{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
   	if err != nil {
   		e.Logger.Error(err)
   		e.Error(500, err, err.Error())
   		return
   	}

	p := actions.GetPermissionFromContext(c)
	list := make([]models.MemberBalanceLog, 0)
	var count int64

	err = s.GetPage(&req, p, &list, &count)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("获取用户余额变更记录失败，\r\n失败信息 %s", err.Error()))
        return
	}

	e.PageOK(list, int(count), req.GetPageIndex(), req.GetPageSize(), "查询成功")
}

// Get 获取用户余额变更记录
// @Summary 获取用户余额变更记录
// @Description 获取用户余额变更记录
// @Tags 用户余额变更记录
// @Param id path int false "id"
// @Success 200 {object} response.Response{data=models.MemberBalanceLog} "{"code": 200, "data": [...]}"
// @Router /api/v1/member-balance-log/{id} [get]
// @Security Bearer
func (e MemberBalanceLog) Get(c *gin.Context) {
	req := dto.MemberBalanceLogGetReq{}
	s := service.MemberBalanceLog{}
    err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}
	var object models.MemberBalanceLog

	p := actions.GetPermissionFromContext(c)
	err = s.Get(&req, p, &object)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("获取用户余额变更记录失败，\r\n失败信息 %s", err.Error()))
        return
	}

	e.OK( object, "查询成功")
}

// Insert 创建用户余额变更记录
// @Summary 创建用户余额变更记录
// @Description 创建用户余额变更记录
// @Tags 用户余额变更记录
// @Accept application/json
// @Product application/json
// @Param data body dto.MemberBalanceLogInsertReq true "data"
// @Success 200 {object} response.Response	"{"code": 200, "message": "添加成功"}"
// @Router /api/v1/member-balance-log [post]
// @Security Bearer
func (e MemberBalanceLog) Insert(c *gin.Context) {
    req := dto.MemberBalanceLogInsertReq{}
    s := service.MemberBalanceLog{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
    if err != nil {
        e.Logger.Error(err)
        e.Error(500, err, err.Error())
        return
    }
	// 设置创建人
	req.SetCreateBy(user.GetUserId(c))

	err = s.Insert(&req)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("创建用户余额变更记录失败，\r\n失败信息 %s", err.Error()))
        return
	}

	e.OK(req.GetId(), "创建成功")
}

// Update 修改用户余额变更记录
// @Summary 修改用户余额变更记录
// @Description 修改用户余额变更记录
// @Tags 用户余额变更记录
// @Accept application/json
// @Product application/json
// @Param id path int true "id"
// @Param data body dto.MemberBalanceLogUpdateReq true "body"
// @Success 200 {object} response.Response	"{"code": 200, "message": "修改成功"}"
// @Router /api/v1/member-balance-log/{id} [put]
// @Security Bearer
func (e MemberBalanceLog) Update(c *gin.Context) {
    req := dto.MemberBalanceLogUpdateReq{}
    s := service.MemberBalanceLog{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
    if err != nil {
        e.Logger.Error(err)
        e.Error(500, err, err.Error())
        return
    }
	req.SetUpdateBy(user.GetUserId(c))
	p := actions.GetPermissionFromContext(c)

	err = s.Update(&req, p)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("修改用户余额变更记录失败，\r\n失败信息 %s", err.Error()))
        return
	}
	e.OK( req.GetId(), "修改成功")
}

// Delete 删除用户余额变更记录
// @Summary 删除用户余额变更记录
// @Description 删除用户余额变更记录
// @Tags 用户余额变更记录
// @Param data body dto.MemberBalanceLogDeleteReq true "body"
// @Success 200 {object} response.Response	"{"code": 200, "message": "删除成功"}"
// @Router /api/v1/member-balance-log [delete]
// @Security Bearer
func (e MemberBalanceLog) Delete(c *gin.Context) {
    s := service.MemberBalanceLog{}
    req := dto.MemberBalanceLogDeleteReq{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
    if err != nil {
        e.Logger.Error(err)
        e.Error(500, err, err.Error())
        return
    }

	// req.SetUpdateBy(user.GetUserId(c))
	p := actions.GetPermissionFromContext(c)

	err = s.Remove(&req, p)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("删除用户余额变更记录失败，\r\n失败信息 %s", err.Error()))
        return
	}
	e.OK( req.GetId(), "删除成功")
}
